import fs from 'node:fs'
import readline from 'node:readline'

const rl = readline.createInterface({
	input: fs.createReadStream('input'),
	output: process.stdout,
	terminal: false
})

let groupcount = 0
let linecount = 0
let overlapcount = 0
rl.on('line', line => {
	let containsRange = []
	let overlapRange = []
	let groups = line.split(',').map(value => value.split('-'))
	let group0Range = range(groups[0][0], groups[0][1])
	let group1Range = range(groups[1][0], groups[1][1])
	containsRange = [
		group0Range.every(elem => group1Range.includes(elem)),
		group1Range.every(elem => group0Range.includes(elem)),
	]
	if (containsRange[0] || containsRange[1]) {
		groupcount++
	}
	overlapRange = [
		group0Range.some(elem => group1Range.includes(elem)),
		group1Range.some(elem => group0Range.includes(elem)),
	]
	if (overlapRange[0] || overlapRange[1]) {
		overlapcount++
	}
	linecount++
})

rl.on('close', () => {
	console.log(`${groupcount} groups fully contain each other`)
	console.log(`${overlapcount} groups overlap each other`)
	console.log(`There are ${linecount} groups in general`)
})

function range(start = 0, end = 0) {
	let rangeArray = []
	for(let i = parseInt(start); i <= end; i++) {
		rangeArray.push(i)
	}
	return rangeArray
}
